<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- icon-top-onScroll -->
    <v-btn
      v-scroll="onScroll"
      v-show="fab"
      fab
      dark
      fixed
      bottom
      right
      color="#428bca"
      @click="toTop"
    >
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top-onScroll -->

    <!-- snackbar -->
    <v-snackbar v-model="snackbar" :timeout="timeout" right="right">
      {{ text }}
      <v-btn color="red" text @click="snackbar = false"> Close </v-btn>
    </v-snackbar>
    <!-- snackbar -->

    <!-- table package -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card>
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title><h1>Package</h1></v-card-title>
                <div>
                  <v-card-title>
                    <v-btn
                      class="mr-1"
                      @click="dialog_add_package = true"
                      type="button"
                      color="#428bca"
                      small
                      dark
                      ><v-icon small class="pr-1">mdi-clipboard-plus</v-icon>
                      Add Package
                    </v-btn>
                    <v-spacer></v-spacer>
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-card-title>
                  <v-data-table
                    :headers="headers"
                    :items="all_package"
                    :search="search"
                  >
                    <template v-slot:item.actions="{ item }">
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-0"
                            @click="edit_package(item)"
                            color="teal"
                          >
                            mdi-pencil
                          </v-icon>
                        </template>
                        <span>Edit</span>
                      </v-tooltip>
                      &nbsp;&nbsp;
                      <v-tooltip top>
                        <template v-slot:activator="{ on, attrs }">
                          <v-icon
                            small
                            v-bind="attrs"
                            v-on="on"
                            class="mx-0"
                            @click="delete_package(item)"
                            color="error"
                          >
                            mdi-delete
                          </v-icon>
                        </template>
                        <span>Delete</span>
                      </v-tooltip>
                    </template>
                  </v-data-table>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table package -->

    <!-- dialog_add_package -->
    <v-dialog v-model="dialog_add_package" max-width="500px" persistent scrollable>
      <v-card>
        <v-card-title class="headline" style="color: white; background: #428bca">Add Package</v-card-title>
        <v-card-text>
          <v-form ref="form_add_package">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12" class="mt-2">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_package.package_name"
                    :rules="package_name_rules"
                    label="package name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pt-0">
                  <v-text-field
                    outlined
                    dense
                    :disabled="form_add_package.flim_upload == 'unlimited'"
                    v-model="form_add_package.flim_upload"
                    :rules="total_film_rules"
                    label="Total Film"
                  ></v-text-field>
                  <v-checkbox
                    class="pt-0"
                    v-model="form_add_package.flim_upload"
                    :rules="total_film_rules"
                    label="unlimited"
                    value="unlimited"
                  ></v-checkbox>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pt-0">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_package.price"
                    :rules="price_rules"
                    label="Price"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pt-0">
                  <v-select
                    outlined
                    dense
                    v-model="form_add_package.time_package"
                    :rules="time_package_rules"
                    :items="list_time"
                    label="Select Package Time"
                  >
                  </v-select>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pt-0">
                  <v-select
                    outlined
                    dense
                    v-model="service"
                    :rules="serviceRules"
                    :items="list_service_addpackage"
                    label="Select Service"
                    multiple
                  >
                  </v-select>
                </v-col>
                <v-col cols="12" :sm="sm" :md="md" v-if="show_lung" class="pt-0">
                  <v-select
                    outlined
                    dense
                    v-model="disease_lung"
                    :rules="disease_lungRules"
                    :items="list_disease_lung"
                    label="Select disease lung"
                    multiple
                  >
                    <template v-slot:selection="{ item, index }">
                      <v-chip v-if="index === 0">
                        <span>{{ item }}</span>
                      </v-chip>
                      <span v-if="index === 1" class="grey--text caption"
                        >(+{{ disease_lung.length - 1 }} others)</span
                      >
                    </template>
                  </v-select>
                </v-col>
                <v-col cols="12" :sm="sm" :md="md" v-if="show_eye" class="pt-0">
                  <v-select
                    outlined
                    dense
                    v-model="disease_eye"
                    :rules="disease_eyeRules"
                    :items="list_disease_eye"
                    label="Select disease eye"
                    multiple
                  >
                    <template v-slot:selection="{ item, index }">
                      <v-chip v-if="index === 0">
                        <span>{{ item }}</span>
                      </v-chip>
                      <span v-if="index === 1" class="grey--text caption"
                        >(+{{ disease_eye.length - 1 }} others)</span
                      >
                    </template>
                  </v-select>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pt-0">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_add_package.notes"
                    label="Note"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancel_add" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_add" style="color: white">
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_add_package -->

    <!-- dialog_edit_package -->
    <v-dialog v-model="dialog_edit_package" max-width="500px" persistent>
      <v-card>
        <v-card-title class="headline" style="color: white; background: #428bca">Edit Package</v-card-title>
        <v-form ref="form_edit">
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_package.package_name"
                    :rules="package_name_rules"
                    label="package name"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pt-0">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_package.flim_upload"
                    :rules="total_film_rules"
                    label="Total Film"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="6" md="6" class="pt-0">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_package.price"
                    :rules="price_rules"
                    label="Price"
                  ></v-text-field>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pt-0">
                  <v-select
                    outlined
                    dense
                    v-model="form_edit_package.time_package"
                    :rules="time_package_rules"
                    :items="list_time"
                    label="Select Package Time"
                  >
                  </v-select>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pt-0">
                  <v-select
                    outlined
                    dense
                    v-model="form_edit_package.service"
                    :rules="serviceRules"
                    :items="list_service"
                    label="Select Service"
                    v-on:input="changeRoute(`${form_edit_package.service}`)"
                    multiple
                  >
                  </v-select>
                </v-col>
                <v-col cols="12" :sm="sm" :md="md" class="pt-0">
                  <v-select
                    outlined
                    dense
                    v-model="form_edit_package.disease"
                    :rules="disease_lungRules"
                    :items="list_edit_disease_lung"
                    v-on:input="changeRoute2(`${form_edit_package.disease}`)"
                    label="Select disease lung"
                    multiple
                  >
                    <template v-slot:selection="{ item, index }">
                      <v-chip v-if="index === 0">
                        <span>{{ item }}</span>
                      </v-chip>
                      <span v-if="index === 1" class="grey--text caption"
                        >(+{{
                          form_edit_package.disease.length - 1
                        }}
                        others)</span
                      >
                    </template>
                  </v-select>
                </v-col>
                <v-col cols="12" sm="12" md="12" class="pt-0">
                  <v-text-field
                    outlined
                    dense
                    v-model="form_edit_package.notes"
                    label="Note"
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
        </v-form>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" @click="cancle_edit" style="color: white">
            Cancel
          </v-btn>
          <v-btn color="blue" @click="save_edit" style="color: white">
            Update
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <!-- dialog_edit_package -->
  </v-app>
</template>

<script>
export default {
  name: "Package",
  data() {
    return {
      api: process.env.VUE_APP_API,
      fab: false,
      snackbar: false,
      text: "",
      timeout: 5000,
      dialog_add_package: false,
      dialog_edit_package: false,
      dialog_delete_package: false,
      dialog_loader: false,
      search: "",
      list_time: [
        "1 week",
        "1 month",
        "2 month",
        "3 month",
        "4 month",
        "5 month",
        "6 month",
        "7 month",
        "8 month",
        "9 month",
        "10 month",
        "11 month",
        "1 year",
      ],
      list_service_addpackage: ["cxr", "retina"],
      list_service: ["cxr", "retina"],
      list_disease_lung: [
        "Abnormal",
        "Tuberculosis",
        "Pneumothorax",
        "Emphysema",
        "Pneumonia",
        "Covid-19",
      ],
      list_edit_disease_lung: [
        "Abnormal",
        "Tuberculosis",
        "Pneumothorax",
        "Emphysema",
        "Pneumonia",
        "Diabetic-eye",
        "Covid-19",
      ],
      list_edit_disease_eye: ["Diabetic-eye"],
      list_disease_eye: ["Diabetic-eye"],
      all_package: [],
      headers: [
        {
          text: "Package Name",
          align: "start",
          value: "package_name",
          sortable: false,
        },
        {
          text: "Total Film Amount",
          align: "start",
          value: "flim_upload",
          sortable: false,
        },
        {
          text: "Price",
          align: "start",
          value: "price",
          sortable: false,
        },
        {
          text: "Service",
          align: "start",
          value: "service",
          sortable: false,
        },
        { text: "Action", value: "actions", sortable: false },
      ],
      form_add_package: {
        flim_upload: "",
        time_package: "",
        price: "",
        package_name: "",
        notes: "",
      },
      // rule
      package_name_rules: [(v) => !!v || "Please enter package name"],
      total_film_rules: [
        (v) => !!v || "Please enter Total Film",
        (v) => /^([0-9,"unlimited"])+$/.test(v) || "Please enter number only!",
      ],
      price_rules: [
        (v) => !!v || "Please enter price",
        (v) => /^([0-9])+$/.test(v) || "Please enter number only!",
      ],
      note_rules: [(v) => !!v || "Please enter note"],
      service: [],
      time_package_rules: [(v) => !!v || "Please enter package time"],
      serviceRules: [
        (v) => !!v || "Please enter Service",
        (v) => v.length != 0 || "Please enter Service",
      ],
      disease_lung: [],
      disease_lungRules: [
        (v) => !!v || "Please enter disease lung",
        (v) => v.length != 0 || "Please enter disease lung",
      ],
      //
      show_lung: false,
      disease_eye: [],
      disease_eyeRules: [
        (v) => !!v || "Please enter disease eye",
        (v) => v.length != 0 || "Please enter disease eye",
      ],
      show_eye: false,
      sm: 12,
      md: 12,
      form_edit_package: {
        notes: "",
        form_edit_package: "",
      },
      select: "",
      session_id: this.$cookies.get("info_login").session_id,
    };
  },
  watch: {
    // list_service(val) {
    //   if (val.length == 1) {
    //     if (val[0] == "cxr") {
    //       this.show_lung = true;
    //       this.show_eye = false;
    //       this.disease_eye = [];
    //       this.sm = 12;
    //       this.md = 12;
    //     } else if (val[0] == "ratina") {
    //       this.show_eye = true;
    //       this.show_lung = false;
    //       this.disease_lung = [];
    //       this.sm = 12;
    //       this.md = 12;
    //     }
    //   } else if (val.length == 2) {
    //     this.show_lung = true;
    //     this.show_eye = true;
    //     this.sm = 12;
    //     this.md = 12;
    //   } else {
    //     this.show_lung = false;
    //     this.show_eye = false;
    //     this.disease_lung = [];
    //     this.disease_eye = [];
    //     this.sm = 12;
    //     this.md = 12;
    //   }
    // },
    service(val) {
      console.log(val);
      if (val.length == 1) {
        if (val[0] == "cxr") {
          this.show_lung = true;
          this.show_eye = false;
          this.disease_eye = [];
          this.sm = 12;
          this.md = 12;
        } else if (val[0] == "retina") {
          this.show_eye = true;
          this.show_lung = false;
          this.disease_lung = [];
          this.sm = 12;
          this.md = 12;
        }
      } else if (val.length == 2) {
        this.show_lung = true;
        this.show_eye = true;
        this.sm = 6;
        this.md = 6;
      } else {
        this.show_lung = false;
        this.show_eye = false;
        this.disease_lung = [];
        this.disease_eye = [];
        this.sm = 12;
        this.md = 12;
      }
    },
  },

  mounted() {
    console.log("api -->", this.api);
    this.get_package();
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 20;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_package() {
      this.dialog_loader = true;
      this.axios
        .get(process.env.VUE_APP_API + "/api/v3/package", {
          params: {
            userlog_id: this.$cookies.get("info_login").user_id,
          },
          headers: {
            Authorization: this.session_id,
          },
        })
        .then((response) => {
          console.log("response", response.data.data);
          this.dialog_loader = false;
          this.all_package = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    cancel_add() {
      this.$refs.form_add_package.reset();
      this.disease_lung = [];
      this.disease_eye = [];
      this.dialog_add_package = false;
    },

    save_add() {
      if (!this.$refs.form_add_package.validate()) return;
      this.form_add_package["service"] = this.service;
      this.form_add_package["disease"] = this.disease_lung;
      this.form_add_package["userlog_id"] = this.$cookies.get("info_login").user_id;
      if (this.disease_eye.length != 0) {
        for (let index = 0; index < this.disease_eye.length; index++) {
          this.form_add_package["disease"].push(this.disease_eye[index]);
        }
      }
      this.dialog_loader = true;
      this.axios
        .post(
          process.env.VUE_APP_API + "/api/v3/package",
          this.form_add_package,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then(() => {
          // console.log("response", response.data.data);
          this.dialog_loader = false;
          this.dialog_add_package = false;
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Add Package success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.$refs.form_add_package.reset();
            this.get_package();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },

    edit_package(item) {
      console.log(item);
      this.form_edit_package = item;
      // this.list_service = item.service;
      this.dialog_edit_package = true;
    },

    cancle_edit() {
      this.dialog_edit_package = false;
      this.get_package();
    },

    save_edit() {
      if (!this.$refs.form_edit.validate()) return;
      this.form_edit_package["userlog_id"] = this.$cookies.get("info_login").user_id;
      this.axios
        .put(
          process.env.VUE_APP_API + "/api/v3/package",
          this.form_edit_package,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then(() => {
          this.dialog_edit_package = false;
          this.$swal({
            icon: "success",
            title: "Success!",
            text: "Edit Package success.",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            this.get_package();
          });
        })
        .catch((error) => {
          this.dialog_loader = false;
          console.log("error", error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false,
          }).then(() => {
            window.location.href = this.api;
          });
        });
    },
    delete_package(item) {
      console.log(item);
      this.$swal({
        title: "Are you sure?",
        text: "You want to delete this package!",
        icon: "warning",
        allowOutsideClick: false,
        showCancelButton: true,
        confirmButtonColor: "#3085d6",
        cancelButtonColor: "#d33",
        confirmButtonText: "Yes, delete it!",
        cancelButtonText: "Cancle",
      }).then((result) => {
        if (result.value) {
          this.axios
            .delete(process.env.VUE_APP_API + "/api/v3/package", {
              params: {
                package_id: item.package_id,
                userlog_id: this.$cookies.get("info_login").user_id,
              },
              headers: {
                Authorization: this.session_id,
              },
            })
            .then((response) => {
              console.log(response.data);
              console.log(response.data.status);
              if (response.data.status == "fail") {
                this.$swal({
                  icon: "error",
                  title: "Error!",
                  text: "package is using.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_package();
                });
              } else {
                this.$swal({
                  icon: "success",
                  title: "Success!",
                  text: "Delete Package success.",
                  confirmButtonText: "OK",
                  allowOutsideClick: false,
                }).then(() => {
                  this.get_package();
                });
              }
            })
            .catch((error) => {
              this.dialog_loader = false;
              console.log("error", error);
              this.$swal({
                icon: "error",
                title: "Error!",
                text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
                confirmButtonText: "OK",
                allowOutsideClick: false,
              }).then(() => {
                window.location.href = this.api;
              });
            });
        }
      });
    },

    changeRoute(val) {
      console.log(val);
      var findRetina = val.includes("retina");
      console.log("findRetina", findRetina);
      if (findRetina == true) {
        const found = this.form_edit_package["disease"].find(
          (element) => element == "Diabetic-eye"
        );
        if (found == "Diabetic-eye") {
          console.log("มี Diabetic-eye แล้ว", found);
        } else {
          this.form_edit_package["disease"].push("Diabetic-eye");
          console.log(this.form_edit_package["disease"]);
        }
      } else {
        console.log("not push Diabetic-eye");
        const index = this.form_edit_package["disease"].indexOf("Diabetic-eye");
        this.form_edit_package["disease"].splice(index, index);
        console.log(this.form_edit_package["disease"]);
      }
      var findCxr = val.includes("cxr");
      console.log("findCxr", findCxr);
      if (findCxr == false) {
        console.log("[]");
        console.log("val-disease=>", this.form_edit_package.disease);
      }
    },

    changeRoute2(val) {
      console.log(val);
      var findDiabeticEye = val.includes("Diabetic-eye");
      console.log("findDiabeticEye", findDiabeticEye);
      if (findDiabeticEye == true) {
        const found = this.form_edit_package["service"].find(
          (element) => element == "retina"
        );
        if (found == "retina") {
          console.log("มี retina แล้ว", found);
        } else {
          this.form_edit_package["service"].push("retina");
          console.log("push->retina", this.form_edit_package["service"]);
        }
      } else {
        console.log("not push retina");
        const index = this.form_edit_package["service"].indexOf("retina");
        this.form_edit_package["service"].splice(index, index);
        console.log(this.form_edit_package["service"]);
      }
    },

    snackbar_alert(error_msg) {
      this.snackbar = true;
      this.text = error_msg;
      this.timeout;
      console.log("snackbar_alert");
    },
  },
};
</script>

<style></style>
